<!-- eslint-disable -->
<template>
	<div class="relative box-border mktext" :class="[heightAuto ? 'h-auto' : footer[1]]">
		<ValidationProvider v-slot="{ errors, ariaMsg, ariaInput }" :rules="rules" :immediate="false" :vid="vid">
			<div
				v-if="!displayonly"
				class="relative border rounded-md outline border-grey-20 focus-within:border-black"
				:class="[
					errorClass,
					{ 'border-error-20': errors.length > 0 },
					`mk-text-input-${variant}`,
					{ 'mk-input-without-label': inputType == 'withoutlabel' },
					mkQtyClass[1],
				]"
			>
				<input
					:id="id || false"
					ref="mk_text_input"
					v-model="inputValue"
					v-focus="setFocus"
					:aria-label="label"
					:type="type"
					:name="id"
					:maxlength="maxlength"
					:value="inputBoxValue"
					:readonly="readOnly"
					v-bind="ariaInput"
					:disabled="disabled"
					autocomplete="off"
					:placeholder="placeholder"
					:onkeypress="inputType == 'withoutlabel' ? 'return event.charCode >= 48 && event.charCode <= 57' : ''"
					:class="[
						inputValue && inputValue.toString().length > 0 && inputType !== 'withoutlabel'
							? 'origin-bottom-left'
							: 'transform-none overflow-ellipsis',
						inputClass,
						{ 'origin-bottom-left transform  text-grey-20': disabled },
						footer[0]
							? ['font-primary-font-regular pl-6', footer[2]]
							: ['font-primary-font-light', mkQtyClass[0], 'px-4'],
						mkQtyClass[1] ? 'pt-0' : footer[0] ? 'pt-0' : 'pt-4',
						disableInput ? 'text-gray-300 pointer-events-none' : '',
					]"
					class="tw-input block w-full p-0 bg-transparent border-none rounded-md focus:ring-transparent font-primary-font-light text-base"
					@blur="focusOut()"
					@keyup="$emit('keyup', $event.target.value)"
					@keydown="$emit('keydown', $event)"
				/>
				<label
					:id="'lbl' + id"
					:label="label"
					:label-sr-only="labelSrOnly"
					:for="id"
					:class="[
						{ 'text-error-20': errors.length > 0 },
						{ 'text-grey-20': disabled },
						inputType == 'withoutlabel' ? 'sr-only' : '',
						footer[0] ? ['-top-10 font-primary-font-regular left-2', footer[3]] : 'font-primary-font-light',
					]"
					class="absolute top-0 p-4 duration-300 pointer-events-none text-md origin-0"
				>
					{{ label }}
				</label>
				<div v-if="maxChar && !value" aria-hidden="true" class="hidden md:block">
					<span class="absolute cursor-pointer top-1/3 right-0 font-primary-font-light-italic text-grey-20">{{
						maxChar
					}}</span>
				</div>
				<span v-if="loading">
					<MKSpinnerAnimation size-class="absolute top-1/3 right-0 h-5 w-5" />
				</span>

				<div
					v-if="iconClass"
					:role="role"
					tabindex="0"
					:class="[iconClass, 'absolute right-4 top-2 text-3xl cursor-pointer text-grey-20']"
					@keydown.enter="$emit('iconClicked')"
					@click="$emit('iconClicked')"
				></div>
			</div>

			<div v-else-if="displayonly">
				<p :id="id" :label="label"></p>
				<p>{{ value }}</p>
			</div>

			<p
				v-show="errors"
				:id="'hlp_err_' + id"
				v-bind="ariaMsg"
				class="mt-1 text-xs font-primary-font-regular text-error-20 md:text-sm"
			>
				{{ errors[0] }}
			</p>
			<p :id="'hlp' + id">{{ helpText }}</p>
		</ValidationProvider>
	</div>
</template>

<script>
import { ValidationProvider } from 'vee-validate';
import { mapState } from 'vuex';
import MKSpinnerAnimation from '~/components/D2C/atoms/MKSpinnerAnimation.vue';
export default {
	name: 'MkInput',
	components: {
		ValidationProvider,
		MKSpinnerAnimation,
	},
	filters: {
		phoneMask(value) {
			if (!value) return '';
			const phone = value.replace(/\D/g, '').match(/(\d{0,3})(\d{0,3})(\d{0,4})/);
			return !phone[2] ? phone[1] : '(' + phone[1] + ') ' + phone[2] + (phone[3] ? '-' + phone[3] : '');
		},
		phoneMaskUK(value) {
			if (!value) return '';
			const phone = value.replace(/\D/g, '').match(/(\d{0,5})(\d{0,6})/);
			return !phone[2] ? phone[1] : phone[1] + ' ' + phone[2];
		},
	},
	props: {
		id: {
			type: String,
			default: null,
		},
		labelSrOnly: {
			type: Boolean,
			default: false,
		},
		type: {
			type: String,
			default: 'text',
		},
		helpText: {
			type: String,
			default: null,
		},
		placeholder: {
			type: String,
			default: ' ',
		},
		maxlength: {
			type: [Number, String],
			default: 999,
		},
		label: {
			type: String,
			default: null,
		},
		value: {
			type: [String, Number],
			default: '',
		},
		validation: {
			type: String,
			default: null,
		},
		disabled: {
			type: Boolean,
			default: false,
		},
		displayonly: {
			type: Boolean,
			default: false,
		},
		hasError: {
			type: Boolean,
			default: false,
		},
		rules: {
			type: String,
			default: null,
		},
		vid: {
			type: String,
			default: '',
		},
		variant: {
			type: String,
			default: '',
		},
		maxChar: {
			type: String,
			default: '',
		},
		iconClass: {
			type: String,
			default: '',
		},
		inputType: {
			type: String,
			default: '',
		},
		inputClass: {
			type: String,
			default: '',
		},
		errorClass: {
			type: String,
			default: '',
		},
		footer: {
			type: Array,
			default: () => [false, '', 'h-14'],
		},
		mkQtyClass: {
			type: Array,
			default: () => ['h-14', ''],
		},
		heightAuto: {
			type: Boolean,
			default: false,
		},
		role: {
			type: String,
			default: '',
		},
		setFocus: {
			type: String,
			default: 'false',
		},
		loading: {
			type: Boolean,
			default: false,
		},
		disableInput: {
			type: Boolean,
			default: false,
		},
		readOnly: {
			type: Boolean,
			default: false,
		},
	},
	data() {
		return {
			blurStyle: false,
			inputBoxValue: this.value,
		};
	},
	computed: {
		...mapState(['isEurope']),
		inputValue: {
			get() {
				if (this.type === 'phoneNumber') {
					if (this.isEurope) {
						return this.$options.filters.phoneMaskUK(this.value);
					} else {
						return this.$options.filters.phoneMask(this.value);
					}
				}
				return this.value;
			},
			set($val) {
				this.inputBoxValue = $val;
				if (this.type === 'phoneNumber') {
					this.$emit('input', $val.replace(/[^0-9]/g, ''));
				} else {
					this.$emit('input', $val);
				}
			},
		},
	},
	mounted() {
		if (this.inputType !== 'withoutlabel') {
			//  this.focusInput()
		}
	},
	methods: {
		focusInput() {
			if (this.value !== '' && this.value !== null && this.label !== null) {
				this.$refs.mk_text_input.focus();
			}
		},
		focusOut() {
			this.blurStyle = true;
		},
	},
};
</script>
<style lang="postcss">
.mk-text-input-outline {
	@apply border-b border-t-0 border-l-0 border-r-0 rounded-none;
}
.mk-text-input-outline-none {
	@apply border-0 border-t-0 border-l-0 border-r-0 rounded-none;
}
.mk-text-input-outline input {
	@apply rounded-none focus:ring-0 pl-0 pb-0;
}
.mktext input,
.mktext input:focus-within {
	@apply transform-none relative;
}
.mk-text-input-outline-none input:placeholder-shown {
	@apply border-0 border-t-0 border-l-0 border-r-0 rounded-none pl-6;
}
.mk-text-input-outline label {
	@apply pl-0 text-base;
}
.mk-text-input-outline input:focus-within ~ label,
.mk-text-input-outline input:not(:placeholder-shown) ~ label {
	@apply ml-0 pl-0 leading-4 pt-2;
}
.mk-text-input-outline input:focus-within,
.mk-text-input-outline input:focus {
	@apply origin-bottom-left pl-0 pb-0 transform-none;
}
.mk-text-input-outline-none input:focus-within,
.mk-text-input-outline-none input:focus {
	@apply pl-6 pb-0 transform-none;
}
.mk-text-input-outline-none input:focus {
	@apply placeholder-transparent;
}
.mk-input-without-label input:focus-within,
.mk-input-without-label input:focus {
	@apply transform-none;
}
input[type='number']::-webkit-inner-spin-button,
input[type='number']::-webkit-outer-spin-button {
	@apply appearance-none m-0;
}
.mktext .mk-text-input-outline input:focus-within,
.mktext .mk-text-input-outline input:focus {
	@apply origin-bottom-left pl-0 pb-0 transform-none outline-none;
}
</style>
